import numpy as np
#----------
#--- 1d ---
#----------
lap = np.array([1,-2,1])
lap_ext = np.zeros(5)
lap_ext[1:4] = lap
bih = np.zeros((5))
for (dx,), f in np.ndenumerate(lap):
	bih[0+dx:3+dx] += f*lap

#----------
#--- 2d ---
#----------
lap = np.array([[0, 1,0],
                [1,-4,1],
                [0, 1,0]])
lap = np.array([[1, 4 ,1],
                [4,-20,4],
                [1, 4 ,1]])/6
lap_ext = np.zeros((5,5))
lap_ext[1:4,1:4] = lap
bih=np.zeros((5,5))
for (dx,dy), f in np.ndenumerate(lap):
	bih[0+dx:3+dx,0+dy:3+dy] += f*lap

#----------
#--- 3D ---
#----------
lap = np.array([[[0, 0,0],
                 [0, 1,0],
                 [0, 0,0]],

                [[0, 1,0],
                 [1,-6,1],
                 [0, 1,0]],

                [[0, 0,0],
                 [0, 1,0],
                 [0, 0,0]]])
#lap = np.array([[[0, 1,0],
                 #[1, 2,1],
                 #[0, 1,0]],

                #[[1,  2,1],
                 #[2,-24,2],
                 #[1,  2,1]],

                #[[0, 1,0],
                 #[1, 2,1],
                 #[0, 1,0]]])#/6

lap_ext = np.zeros((5,5,5))
lap_ext[1:4,1:4,1:4] = lap
bih = np.zeros((5,5,5))
for (dx,dy,dz), f in np.ndenumerate(lap):
	bih[0+dx:3+dx,0+dy:3+dy,0+dz:3+dz] += f*lap

print(lap)
print(bih)
print("sum(lap)=",np.sum(lap))
print("sum(bih)=",np.sum(bih))
